Subject: Re: [External] : Re: bug#65348: INITIAL-INPUT in completing-read repeats same entry twice consecutively

From: Heime <[email-masked]>
Date: Sun, 20 Aug 2023 05:42:43 +0000

------- Original Message -------
On Sunday, August 20th, 2023 at 7:19 AM, Eli Zaretskii <[email-masked]> wrote:

> > From: Drew Adams [email-masked]
> > CC: "[email-masked]" [email-masked]
> > Date: Sat, 19 Aug 2023 16:20:07 +0000
> > 
> > > You can try starting a discussion on emacs-devel if you want. But the
> > > above-mentioned change was not done arbitrarily, and does have its
> > > merit in many situations,
> > 
> > I don't see that it has merit in any situation.
> 
> 
> The situations where it's useful are obvious.
> 
> > I haven't seen a single example cited where it
> > has merit. Can you point to one?
> 
> 
> What for? so you could argue endlessly that you disagree? We already
> know that you don't like that change and think it should be reverted,
> so what would be the purpose of another discussion about that?
> 
> > And I think you agreed that it's obvious that in
> > some cases (such as the `C-h v' example cited in
> > bug #64656) it's clearly not helpful but harmful.
> 
> In some, quite extreme, case, indeed, it is not useful. That doesn't
> yet mean it is always useless.

Using a list in collection for cycling using an 'initial-value' ('default-value'
if that what most people would like it to be, is not an extreme case.  
 
> Again, we've been through that, and I really have no reason to do it
> again. Life is too short.

Will 'INITIAL-VALUE' be deprecated and made obsolete.  Then we would be using
'DEF' ?  One thing that bothers me quite a bit is the idea of obsolescence,
but in practice we keep things as they are for the sake of not breaking compatibility
with older versions.  The result is a complicated call definitions that while
they exist, a concurrent rule is actually in effect suggesting others what should
be used and not used.  

While providing multiple ways of accomplishing tasks can offer flexibility and 
accommodate various preferences and use cases, leaving conflicting or redundant
features leads to confusion and complexity for developers working with the codebase.

Deprecation should mean removing them in newer versions with instructions to developers
on migrating to the alternative.

Can there be the option to place an item from the collection (call it 'INITIAL', 'DEF', 'WHATEVER')
that appears as soon as `completing-read` is called ?